/****************************************************************************
Copyright (C) 2012 HidraVFX development team
            <https://launchpad.net/~hidravfx-dev-team>

This file is part of the HidraVFX project.

HidraVFX is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

HidraVFX is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HidraVFX. If not, see <http://www.gnu.org/licenses/>.
****************************************************************************/

#ifndef DISTANCE_H_
#define DISTANCE_H_

extern double valami(double dx, double dy);
extern double cubics(double dx, double dy);
extern double heart(double dx, double dy);
extern double tentacles(double dx, double dy);
extern double clover(double dx, double dy);
extern double zigzag(double dx, double dy);
extern double flower(double dx, double dy);
extern double flower2(double dx,double dy);
extern double spiral(double dx,double dy);
extern double spiral2(double dx, double dy);
extern double euclidian(double dx, double dy);
extern double baroque(double dx, double dy);
extern double sqreuclidian(double dx, double dy);
extern double manhattan(double dx,double dy);
extern double maxnorma(double dx, double dy);
extern double xmanhattan(double dx, double dy);
extern double okta(double dx, double dy);
extern double circle(double dx, double dy);
extern double correlation(double x1, double x2, double y1, double y2);
extern double kendallsCorrelation(double x1, double x2,double y1, double y2);
extern double chisquare(double x1, double x2, double y1, double y2);
extern double cosin(double x1, double x2, double y1, double y2);
extern double circleDist(double x1, double x2, double y1, double y2);
extern double oktaDist(double x1, double x2, double y1, double y2);
extern double euclidianDist(double x1, double x2, double y1, double y2);
extern double fasteuclidianDist(double x1, double x2, double y1, double y2);
extern double sqreuclidianDist(double x1, double x2, double y1, double y2);
extern double manhattanDist(double x1, double x2, double y1,double y2);
extern double camberraDist(double x1, double x2, double y1, double y2);
extern double minkovskyDist(double x1,double x2,double y1,double y2, int n);
extern double maxnormaDist(double x1,double x2,double y1, double y2);
extern double xmanhattanDist(double x1, double x2, double y1, double y2);
extern double euclidian3Dist(double x1,double x2,double y1,double y2,double z1,double z2);
extern double manhattan3Dist(double x1,double x2,double y1,double y2,double z1,double z2);
extern double minkovsky3Dist(double x1,double x2,double y1,double y2,double z1,double z2,double n);
extern double camberra3Dist(double x1,double x2,double y1,double y2,double z1,double z2);
extern double fasteuclidian3Dist(double x1,double x2,double y1,double y2,double z1,double z2);
extern double sqreuclidian3Dist(double x1,double x2,double y1,double y2,double z1,double z2);
extern double maxnorma3Dist(double x1,double x2,double y1,double y2,double z1,double z2);
extern double xmanhattan3Dist(double x1,double x2,double y1,double y2,double z1,double z2);

#endif
