/****************************************************************************
Copyright (C) 2012 HidraVFX development team
            <https://launchpad.net/~hidravfx-dev-team>

This file is part of the HidraVFX project.

HidraVFX is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

HidraVFX is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HidraVFX. If not, see <http://www.gnu.org/licenses/>.
****************************************************************************/

#ifndef SPLINE_H_
#define SPLINE_H_

#include "vertex.h"

/*
typedef  tpoint[]  tpointarray ;
typedef  double[]  trunarray ;
typedef  array[] of tpoint  t3dpointgrid ;
*/

typedef struct
{
  tpoint point[4];
} tcubicspline;

extern tcubicspline tcubicspline_of_tpoint(tpoint p0,tpoint p1,tpoint p2,tpoint p3);
extern tcubicspline tcubicspline_of_double(double p0x,double p0y,double p1x,double p1y,double p2x,double p2y,double p3x,double p3y);
extern tpoint bspline_of_tpoint(tpoint p0, tpoint p1,tpoint p2, double u);
extern tpoint bspline_of_tcubicspline(tcubicspline p, double u);
extern tpoint catmullrom_of_tcubicspline(tcubicspline p, double u);
extern tpoint bezier_of_2tpoints(tpoint p0,tpoint p1, double u);
extern tpoint bezier_of_3tpoints(tpoint p0,tpoint p1,tpoint p2,double u);
extern tpoint bezier_of_tcubicspline(tcubicspline p,double u);
extern tpoint bezierradius_of_tcubicspline(tcubicspline bezier, double u);

#endif
